import time
import paho.mqtt.client as paho
import zlib
import os #for the seek function to work
import base64
import zipfile
# import binascii

#set starting defaults of status and filedata
status = "empty"
filedata = "empty"
#track and request split counts variables
#expected_split_cnt = 0
max_split_cnt=0
curr_split_cnt=1
#server waiting for esp32 to respond to first variables
curr = 0
start = 0
#data waiting timeout variables
datastart = 0
datacurr = 0
serverReadyForDataFlag = 0
#checksum variables
rec_checksum = 0
calc_checksum = 0
#file read variables
TRANSFER_READ_BUFF = 4000 #512 #when esp32 is expecting 1024 total data then it is ok to send 800 from this parameter
#2700 for 2848
res = 0
fileComplete = 0
esp_req_filenames = ""
export_dir_name = "serverWeb"


def server_to_esp32(brokerip,port,keepAlive,cid,extractloc,zippath,uniqueid,filetopic,statustopic,timeout,username,password):
    #set starting defaults of status and filedata
    global start
    global curr
    global datastart
    global datacurr
    global serverReadyForDataFlag
    #global expected_split_cnt
    global currentTryCount
    global MaxTryCount
    global TRANSFER_READ_BUFF
    global esp_req_filenames
    # The callback for when a PUBLISH message is received from the server.
    def on_message(client, userdata, message):
        #global expected_split_cnt
        global rec_split_cnt
        global currentTryCount
        global max_split_cnt
        global curr_split_cnt
        global status
        global curr
        global start
        global serverReadyForDataFlag
        global res
        global fileComplete
        global TRANSFER_READ_BUFF
        global esp_req_filenames
        global datastart
        
        #print("Receiving message")
        #print(message.topic)
        if (message.topic == filetopic):
            #save_payload(message.payload, filename)
            print("Receiving message from filedata")
            
        elif (message.topic == statustopic):
            #deal with status from ESP32
           
            status = (message.payload).decode('ascii')
            print("status1 message: ", status )
            
            status = status.split(',')
            print("status1 message: ", status )
          
            if(len(status) > 0  and status[0] == uniqueid):
                # print("Correct UID received")
                if(status[1] == "ESP32_ready"):
                    print("####in if ESP32_ready")
                    start=time.time()
                    
                    if(status[2] == uniqueid):
                        
                        c.publish(statustopic, uniqueid+",Server_ready",1,True)#without retain=true
                    else:
                        print("Invalid uid: ", status[2] )
               
                elif(status[1] == "srequest"):
                    print("####in if srequest")
                    start=time.time()
                    esp_req_filenames_def = status[2]
                    esp_req_filenames = os.path.join(os.getcwd(), export_dir_name,esp_req_filenames_def)
                    print("requested file: ",esp_req_filenames)
                    
                    try:
                        f=open(esp_req_filenames, "rb")
                    except Exception as err:
                        print("server File cannot be opened")
                        #f.close()
                        fileOpened=0
                        c.publish(statustopic, uniqueid+",File_error",1,True)
                    else:
                        fileOpened=1
                        #f.close()
                        f.seek(0,os.SEEK_END)
                        res = f.tell()
                        print("filesize is")
                        print(res)
                        max_split_cnt = (res + (TRANSFER_READ_BUFF-1))/ TRANSFER_READ_BUFF 
                        print("max split count is:")
                        max_split_cnt=int(max_split_cnt)
                        if(max_split_cnt==0):#when the file is of size 0KB
                            max_split_cnt=1
                        print(max_split_cnt)
                        #c.publish(statustopic, "totalsplit,"+maxSplit,1,True)
                        # c.publish(filetopic, uniqueid+",scheck,"+esp_req_filenames_def+","+uniqueid,1,True)
                        c.publish(filetopic, uniqueid+",scheck,"+esp_req_filenames_def,1,True)
                ##
                elif(status[1] == "ssend"):
                    # print("inside ssend case")
                    datastart = time.time()#reset the timer
                    #datacurr = 0
                    flag=0
                    serverReadyForDataFlag = 1
                    rec_split_cnt = int(status[2])
                    #compare currSplit,expectedSplit
                    if(curr_split_cnt==rec_split_cnt):
                        flag=1
                    elif (curr_split_cnt==max_split_cnt):
                        if(fileComplete==1):
                            flag=0
                        else:
                            curr_split_cnt = rec_split_cnt
                            flag=1
                    elif (rec_split_cnt==0):
                        flag=0
                    elif (curr_split_cnt+1==rec_split_cnt):
                        curr_split_cnt=rec_split_cnt
                        flag=1
                    elif (curr_split_cnt>rec_split_cnt):
                        curr_split_cnt=rec_split_cnt
                        flag=1
                    else:
                        flag=0
                    # print("flag ="+str(flag)+" current split = "+str(curr_split_cnt)+" max split count = "+str(max_split_cnt))
                    if(flag==1 and curr_split_cnt<=max_split_cnt):
                        f=open(esp_req_filenames, "rb")
                        #file exception was handled earlier
                        pos=(curr_split_cnt-1)*TRANSFER_READ_BUFF
                        f.seek(pos)#,os.SEEK_SET
                        r=f.read(TRANSFER_READ_BUFF)
                        calc_checksum = zlib.crc32(r)
                        #error check for the read required here
                        if(r):
                            binary = uniqueid+","+str(curr_split_cnt)+","+ str(calc_checksum)+","
                            binary = binary.encode('UTF-8')    
                            c.publish(filetopic, binary+r,1,True)
                            # print(binary+r)
                        else:
                            print("read is empty")
                            ##below is to facilitate for 0KB files that might exist
                            binary = uniqueid+","+str(curr_split_cnt)+","+ str(calc_checksum)+","
                            binary = binary.encode('UTF-8')    
                            c.publish(filetopic, binary+r,1,True)
                        f.close()
                        curr_split_cnt=curr_split_cnt+1 
                elif(status[1] == "ESPready_data"):
                    c.publish(statustopic, uniqueid+",totalsplit,"+str(max_split_cnt),1,True)
                    curr_split_cnt = 1
            # else:
            #     print("Wrong UID received or empty status received")
            # elif(status[0] == "srequest"):
            #     print("####in if srequest2")
            #     start=time.time()
            #     esp_req_filenames_def = status[1]
            #     esp_req_filenames = os.path.join(os.getcwd(), export_dir_name,esp_req_filenames_def)
            #     print("requested file: ",esp_req_filenames)
            
            #     if(status[2] == uniqueid):
                
            #         try:
            #             f=open(esp_req_filenames, "rb")
            #         except Exception as err:
            #             print("server File cannot be opened")
            #             #f.close()
            #             fileOpened=0
            #             c.publish(statustopic, uniqueid+",File_error",1,True)
            #         else:
            #             fileOpened=1
            #             #f.close()
            #             f.seek(0,os.SEEK_END)
            #             res = f.tell()
            #             print("filesize is")
            #             print(res)
            #             max_split_cnt = (res + (TRANSFER_READ_BUFF-1))/ TRANSFER_READ_BUFF 
            #             print("max split count is:")
            #             max_split_cnt=int(max_split_cnt)
            #             if(max_split_cnt==0):#when the file is of size 0KB
            #                 max_split_cnt=1
            #             print(max_split_cnt)
            #             #c.publish(statustopic, "totalsplit,"+maxSplit,1,True)
            #             c.publish(filetopic, uniqueid+",scheck,"+esp_req_filenames_def+","+uniqueid,1,True)
            #     else:
            #         print("Invalid uid: ", status[2] )

              
                     
    # The callback for when the client receives a CONNACK response from the server.
    def on_connect(client, userdata, flags, rc):
        print("Connected with result code "+str(rc))
        # Subscribing in on_connect() means that if we lose the connection and
        # reconnect then subscriptions will be renewed.
        c.subscribe(statustopic,1)
        c.subscribe(filetopic,1)


    print("Extracting the server files from "+zippath)
    with zipfile.ZipFile(zippath, 'r') as zip_ref:
        # Get a list of all file and directory paths in the zip file
        all_paths = zip_ref.namelist()

        # Find the common prefix among all paths
        common_prefix = os.path.commonprefix(all_paths)

        # Split the common prefix to get the root directory
        root_directory = os.path.dirname(common_prefix)

        print("root = "+root_directory)
        export_dir_name=extractloc+"/"+root_directory

        zip_ref.extractall(path=extractloc)

    print("Starting. Assumed the button has been pressed by user")
    c=paho.Client(client_id=cid, clean_session=False)#was True before
    c.on_connect = on_connect
    c.on_message = on_message #when a publish from broker is received
    c.username_pw_set(username, password)
    c.connect(brokerip,port,keepAlive)#throw error and end program if there is connection error
    c.loop_start()
    # c.publish(statustopic, "empty",1,False)
    start = time.time()
    # c.publish(statustopic, "empty",1,True)
    c.publish(statustopic, uniqueid+",empty",1,True)
    while True:
        #print("testing the loop")
        #print("maxsplitcount")
        #print(max_split_cnt)
        #time.sleep(1)
        if(len(status) > 0  and status[0] == uniqueid):
            if(status[1]=="empty" or any("ESP32_ready" in sub for sub in status[1])):
                curr = time.time()
        if(curr - start > 120):#test this timeout. 60 is possible??
            print("ESP32 has not responded time:"+str(curr - start))
            c.publish(statustopic, "",1,True)#to reset
            c.publish(filetopic,"",1,True)#to reset
            c.loop_stop()
            break
        if(any("filecomplete" in sub for sub in status)):
            print("File transfer is complete")
            datastart = 0
            datacurr = 0
            start = time.time()
            curr = time.time()
            serverReadyForDataFlag = 0
            c.publish(filetopic,"",1,True)#to stop unnecessary writes
            c.publish(statustopic, "",1,True)#reset status
            # status==""
            # c.loop_stop()
            # break
        if(any("File_error" in sub for sub in status)):
            print("File could not be opened or does not exist. Try later")
            c.publish(statustopic, "",1,True)#to reset
            c.publish(filetopic,"",1,True)#to reset
            c.loop_stop()
            break
        if(any("updatecompete" in sub for sub in status)):
            print("File sync process is complete")
            datastart = 0
            datacurr = 0
            serverReadyForDataFlag = 0
            c.publish(filetopic,"",1,True)#to stop unnecessary writes
            c.publish(statustopic, "",1,True)#reset status
            c.loop_stop()
            break
        if(any("updatefailed" in sub for sub in status)):
            print("File sync process could not be started")
            datastart = 0
            datacurr = 0
            serverReadyForDataFlag = 0
            c.publish(filetopic,"",1,True)#to stop unnecessary writes
            c.publish(statustopic, "",1,True)#reset status
            c.loop_stop()
            break
        if(serverReadyForDataFlag == 1):
            #print("serverchecking for timeout")
            # datastart = time.time()
            datacurr = time.time()
            if(datacurr-datastart>60):
                print("ESP32 has not responded in "+str(datacurr-datastart))
                datastart = 0
                datacurr = 0
                c.publish(statustopic, "",1,True)#to reset
                c.publish(filetopic,"",1,True)#to reset
                c.loop_stop()
                break

                
                
                


