import time
import paho.mqtt.client as paho
import zlib

#brokerip1="192.168.8.101"  
#filename1="/SDHC/system.db"#"/SDHC/system.db""/SDHC/data3.db"
#filename21="C:/Workspace/test6.txt" 
#uniqueid1="8989898989"

#set starting defaults of status and filedata
status = "empty"
filedata="empty"
#track and request split counts variables
expected_split_cnt = 0
max_split_cnt=0
rec_split_cnt=0
#server waiting for esp32 to respond to first variables
curr = 0
start = 0
#data waiting timeout variables
datastart = 0
datacurr = 0
serverReadyForDataFlag = 0
currentTryCount = 0
MaxTryCount = 5
#checksum variables
rec_checksum = 0
calc_checksum = 0

def esp32_to_server(brokerip,filename,filename2,uniqueid):
    #set starting defaults of status and filedata
    #status = "empty"
    #filedata="empty"
    #track and request split counts variables
    #expected_split_cnt = 0
    #max_split_cnt=0
    #rec_split_cnt=0
    #server waiting for esp32 to respond to first variables
    #curr = 0
    #start = 0
    #data waiting timeout variables
    #datastart = 0
    #datacurr = 0
    #serverReadyForDataFlag = 0
    #currentTryCount = 0
    #MaxTryCount = 5
    global start
    global curr
    global datastart
    global datacurr
    global serverReadyForDataFlag
    global expected_split_cnt
    global currentTryCount
    global MaxTryCount

    # The callback for when a PUBLISH message is received from the server.
    def on_message(client, userdata, message):
        global expected_split_cnt
        global rec_split_cnt
        global currentTryCount
        global max_split_cnt
        global status
        global curr
        global start
        global serverReadyForDataFlag
        #print("Receiving message")
        #print(message.topic)
        if (message.topic == "topic/filedata"):
            #save_payload(message.payload, filename)
            #print("Receiving message from filedata")
            #print(message.payload)
            ##add additional logic for saving to file here
            if((max_split_cnt>0) and (status[0] == "send")):
                ## status[1] here gives the split count in the send,# status
                save_payload(message.payload, filename2)
        elif (message.topic == "topic/status"):
            #deal with status from ESP32
            #print("Receiving message from status")
            #print(message.payload)
            status = (message.payload).decode('ascii')
            #print(status.split(','))
            status = status.split(',')
            #print("size of status is",len(status))
            if(status[0] == "ESP32_ready"):
                #print("We know now that ESP32 is ready")
                curr = start
                c.publish("topic/status", "Server_ready",1,True)#without retain=true
                #previous message was being received when restarting this client
                c.publish("topic/filedata", "check,"+filename+","+uniqueid,1,True)
            #elif(status[0] == "Server_ready"):
            #    print("We know now that Server_ready was sent successfully to the broker")    
            elif(status[0] == "File_error"):
                #print("File could not be opened or does not exist. Try later")
                #break
                c.publish("topic/status", "",1,True)#if we send empty the process will start from the top
                c.publish("topic/filedata","",1,True)#to stop unnecessary writes
            elif(status[0] == "totalsplit"):
                #print("Total count received ESP32 to is ready to send file")
                #break
                max_split_cnt = int(status[1])
                #print("max print count received")
                #print(max_split_cnt)
                expected_split_cnt = 1
                c.publish("topic/filedata","",1,True)#to stop unnecessary writes
                c.publish("topic/status", "send,"+str(expected_split_cnt),1,True)#inform esp32 we are ready to proceed with data
                currentTryCount = 0
            elif(status[0] == "send"):
                datastart = time.time()#reset the timer
                #datacurr = 0
                serverReadyForDataFlag = 1

    # save the filedata into a file        
    def save_payload(payload, filename):
        global filedata
        global currentTryCount
        global rec_split_cnt
        global expected_split_cnt
        global max_split_cnt
        global rec_checksum
        global calc_checksum
        ##global status
        if filedata:
            currentTryCount=0
            filedata=payload
            filedata = filedata.split(",".encode())
            #print("filedata")
            #print(payload)
            #print(filedata)
            rec_split_cnt=filedata[0].decode('ascii')
            rec_split_cnt=int(rec_split_cnt)
            #get only the first split. recombine with ',' delimiter the others or
            #payload will be split everywhere there is a ',' delimiter
            rec_checksum=filedata[1].decode('ascii')
            rec_checksum=int(rec_checksum,16)
            x = len(filedata)
            #print("packet was split to")
            #print(x)
            #for i in x:
            #    data=data+filedata[i]
            #an alternative for below would be to calculate number of characters for
            #split number and remove or skip that section in the payload
            #please check this. it is better than doing a while loop to recombine
            data = b''
            i = 3 #increase this by 1 when checksum is being sent. otherwise 2
            while i < x:
                data=data+filedata[i-1]+b','
                i += 1
            if (i==x):
                data=data+filedata[i-1]
            #print("received split count")
            #print(rec_split_cnt)
            #print("expected split count")
            #print(expected_split_cnt)
            #print(filedata[1])
            ##print(data)
            #print("Saving file: "+filename)
            #first check checksum before the count
            #calc_checksum = findChecksum(data,128)
            #z=0;
            #sumcheck=0;
            calc_checksum=0
            #while (z<512): #while (z<1024):
            #    sumcheck=sumcheck+data[z]
            #    #calc_checksum=~sumcheck
            #    z=z+1
            ##calc_checksum=~sumcheck
            #calc_checksum=sumcheck%64 #64 predetermined
            #newCRC
            #print("new CRC values")
            #print(zlib.crc32(data))
            #print(hex(zlib.crc32(data)))
            calc_checksum = zlib.crc32(data)
            #print("sum is")
            #print(sumcheck)
            #print("check is")
            #print(calc_checksum)
            #print("received checksum")
            #print(rec_checksum)
            #print(hex(rec_checksum))
            #print("calculated checksum")
            #print(calc_checksum)
            #print(hex(calc_checksum))
                
            if(calc_checksum==rec_checksum):
                #
                if(rec_split_cnt == expected_split_cnt):
                    #print("Saving file: "+filename)
                    f=open(filename, "ab")
                    f.write(data)
                    f.close()
                    if(rec_split_cnt==max_split_cnt):
                        print("File is complete")
                        expected_split_cnt=0
                        c.publish("topic/status", "filecomplete",1,True)#if we send empty the process will start from the top
                        c.publish("topic/filedata","",1,True) 
                    else:
                        expected_split_cnt=expected_split_cnt+1
                        c.publish("topic/status", "send,"+str(expected_split_cnt),1,True)
                else:
                    c.publish("topic/status", "send,"+str(expected_split_cnt),1,True)#ask to send the split we are expecting
            else:
                c.publish("topic/status", "send,"+str(expected_split_cnt),1,True)
                print("checksum failed")
                     
    # The callback for when the client receives a CONNACK response from the server.
    def on_connect(client, userdata, flags, rc):
        print("Connected with result code "+str(rc))
        # Subscribing in on_connect() means that if we lose the connection and
        # reconnect then subscriptions will be renewed.
        c.subscribe("topic/status",1)
        c.subscribe("topic/filedata",1)
        
    print("Starting. Assumed the button has been pressed by user")
    c=paho.Client(client_id="py", clean_session=False)#was True before
    c.on_connect = on_connect
    c.on_message = on_message #when a publish from broker is received
    c.connect(brokerip,1883,60)#throw error and end program if there is connection error
    c.loop_start()
    start = time.time()
    while True:
        #print("testing the loop")
        #print("maxsplitcount")
        #print(max_split_cnt)
        #time.sleep(1)
        if(status=="empty"):
            curr = time.time()#we take the current timer for timeout here
        if(curr - start > 30):
            print("ESP32 has not responded")
            c.loop_stop()
            break
        if(status[0]=="filecomplete"):
            print("File transfer is complete")
            datastart = 0
            datacurr = 0
            serverReadyForDataFlag = 0
            #c.publish("topic/filedata","",1,True)#to stop unnecessary writes
            c.publish("topic/status", "",1,True)#reset status
            c.loop_stop()
            break
        if(serverReadyForDataFlag == 1):
            #print("serverchecking for timeout")
            #datastart = time.time()
            datacurr = time.time()
            if(currentTryCount>MaxTryCount):
                currentTryCount=0
                datastart = 0
                datacurr = 0
                print("serverchecking for timeout triggered after max count")
                c.loop_stop()
                break
            if(datacurr-datastart>60):
                currentTryCount=currentTryCount+1
                datastart = time.time()
                #publish asking for resend
                if(expected_split_cnt>0):
                    c.publish("topic/status", "send,"+str(expected_split_cnt),1,True)#inform esp32 to send expectedsplit
                
                
                
        
    #c.publish#"topic/status"
    #c.publish#"topic/filedata"
    # Blocking call that processes network traffic, dispatches callbacks and
    # handles reconnecting.
    # Other loop*() functions are available that give a threaded interface and a
    # manual interface
    #c.loop_forever()
    #call loop_stop at an appropriate point
    #c.loop_stop()

    #additional information on
    #publish(topic, payload=None, qos=0, retain=False)



